#include <time.h>
#include <stdlib.h>
#include <qdos.h>
#include <stdio.h>

char _prog_name[]="partial screen 2 sprite";
char _version[]="1.0";
char _copyright[]="Absolutly Free";

void (*_consetup)()=consetup_title;
main(argc,argv)
char argc;
char **argv;
{
FILE *in,*out;
unsigned char *buffer;
short height,width,i,j;
if (argc!=4) {printf("Usage : %s in_blk out_asm name\n\tin_blk is a partial screen block file\n\tout_asm is a sprite definition in Asm\n\tname : name of the sprite",argv[0]); exit(0);}

in=fopene(argv[1],"r",1); /* search data then prog directory */
if (!in) {printf("Input file : not found\n"); exit(0);}

out=fopen(argv[2],"w"); /* in data directory, default */
if (!out) {printf("Output file : Error (Cannot open)\n"); exit(0);}
fprintf(out,
"* Automatically Created Sprite From Part of Picture\n* Program by Jrme Grimbert (QLCF 189)\n* Freely available\n* source file : %s\n* Compile with QMAC\n*\n*\n        section sprite\n        xdef   _%s\n",
            argv[1],argv[3]);
fread(&width,2,1,in);
fread(&height,2,1,in);
buffer=malloc(width*height/4); /* Width x Heigth : 8 pixel per 2 bytes */
if (!buffer) {
   fclose(in);
   fclose(out);
   printf("Run out of allocable memory...\n"); exit(0);
   }
fread(buffer,width*height/4,1,in);
fprintf(out,"_%s\n        dc.w $0100,$0000\n",argv[3]);
fprintf(out,"         dc.w %d,%d,0,0\n",width,height);
fprintf(out,"         dc.l spri-*\n");
fprintf(out,"         dc.l mask-*\n");
fprintf(out,"         dc.l 0\nspri\n");
for(i=0,j=width*height/8;j;j--,i+=2)
    fprintf(out,"        dc.w $%02.0x%02.0x\n",0xff&(unsigned char)buffer[i],0xff&(unsigned char)buffer[i+1]);
fprintf(out,"mask\n");
for(;i;i-=2) fprintf(out,"        dc.w $ffff\n");
fprintf(out,"*\n*\n*\n        END\n*\n");
fclose(in);
fclose(out);

}
